diff --git a/distros/distros.pt-br.po b/distros/distros.pt-br.po
index 082a616..6dfd23d 100644
--- a/distros/distros.pt-br.po
+++ b/distros/distros.pt-br.po
@@ -1,17 +1,17 @@
 # Brazilian Portuguese translation of http://www.gnu.org/distros/distros.html
-# Copyright (C) 2015 Free Software Foundation, Inc.
+# Copyright (C) 2017 Free Software Foundation, Inc.
 # This file is distributed under the same license as the gnu.org article.
 # Rafael Beraldo <rberaldo@cabaladada.org>, 2012.
 # Aslan Carlos <aslancarlos@gmail.com>, 2012.
 # Arthur Rodrigues Araruna <araruna@gmail.com>, 2012.
 # May 2014: trivial update (T. Godefroy).
-# Rafael Fontenelle <rafaelff@gnome.org>, 2012, 2016.
+# Rafael Fontenelle <rafaelff@gnome.org>, 2012, 2016, 2017.
 # Cassiano dos Santos <caco@member.fsf.org> (proofread), 2016.
 msgid ""
 msgstr ""
 "Project-Id-Version: distros.html\n"
 "POT-Creation-Date: 2017-10-16 18:55+0000\n"
-"PO-Revision-Date: 2017-05-20 16:20-0300\n"
+"PO-Revision-Date: 2017-10-22 19:59-0200\n"
 "Last-Translator: Rafael Fontenelle <rafaelff@gnome.org>\n"
 "Language-Team: Brazilian Portuguese <www-pt-br-general@gnu.org>\n"
 "Language: pt_BR\n"
@@ -20,6 +20,7 @@ msgstr ""
 "Content-Transfer-Encoding: 8bit\n"
 "Plural-Forms: nplurals=2; plural=(n > 1);\n"
 "X-Generator: Virtaal 1.0.0-beta1\n"
+"X-Outdated-Since: 2017-10-16 18:55+0000\n"
 
 #. type: Content of: <title>
 msgid "GNU/Linux Distros - GNU Project - Free Software Foundation"
@@ -34,21 +35,6 @@ msgid "GNU/Linux Distros"
 msgstr "Distros GNU/Linux"
 
 #. type: Content of: <p>
-# | Free [-GNU/Linux system-] distributions (or &ldquo;distros&rdquo;) {+of
-# | the <a href=\"/gnu/linux-and-gnu.html\">GNU/Linux system</a>+} only
-# | include and only propose free software.  They reject non-free
-# | applications, non-free programming platforms, non-free drivers, non-free
-# | firmware &ldquo;blobs&rdquo;, and any other non-free software and
-# | documentation.  If they discover that by mistake some had been included,
-# | they remove it.
-#, fuzzy
-#| msgid ""
-#| "Free GNU/Linux system distributions (or &ldquo;distros&rdquo;) only "
-#| "include and only propose free software.  They reject non-free "
-#| "applications, non-free programming platforms, non-free drivers, non-free "
-#| "firmware &ldquo;blobs&rdquo;, and any other non-free software and "
-#| "documentation.  If they discover that by mistake some had been included, "
-#| "they remove it."
 msgid ""
 "Free distributions (or &ldquo;distros&rdquo;) of the <a href=\"/gnu/linux-"
 "and-gnu.html\">GNU/Linux system</a> only include and only propose free "
@@ -57,12 +43,12 @@ msgid ""
 "other non-free software and documentation.  If they discover that by mistake "
 "some had been included, they remove it."
 msgstr ""
-"Distribuições livres do sistema GNU/Linux (ou “distros”) incluem e sugerem "
-"apenas Software Livre. Elas rejeitam aplicações não livres, plataformas de "
-"programação não livres, drivers não livres, firmware “<em>blobs</em><sup><a "
-"href=\"#TransNote1\">1</a></sup>” não livres, e qualquer outro software ou "
-"documentação não livre. Se elas descobrem que por engano incluíram software "
-"assim, elas o removem."
+"Distribuições livres( ou \"distros\") do <a href=\"/gnu/linux-and-gnu.html\">"
+"sistema GNU/Linux</a> incluem e sugerem apenas Software Livre. Elas rejeitam "
+"aplicações não livres, plataformas de programação não livres, drivers não "
+"livres, firmware “<em>blobs</em><sup><a href=\"#TransNote1\">1</a></sup>” "
+"não livres, e qualquer outro software ou documentação não livre. Se elas "
+"descobrem que por engano incluíram software assim, elas o removem."
 
 #. type: Content of: <h3>
 msgid "Free GNU/Linux Distros"
@@ -281,7 +267,6 @@ msgstr ""
 "Wikipédia</a>.</li>\n"
 "</ol>"
 
-# type: Content of: <div><p>
 #. type: Content of: <div><div><p>
 msgid ""
 "Please send general FSF &amp; GNU inquiries to <a href=\"mailto:gnu@gnu.org"
@@ -323,32 +308,18 @@ msgstr ""
 "envio de traduções das páginas desse site."
 
 #. type: Content of: <div><p>
-# | Copyright &copy; 2014, [-2015-] {+2015, 2017+} Free Software Foundation,
-# | Inc.
-#, fuzzy
-#| msgid "Copyright &copy; 2014, 2015 Free Software Foundation, Inc."
 msgid "Copyright &copy; 2014, 2015, 2017 Free Software Foundation, Inc."
-msgstr "Copyright &copy; 2014, 2015 Free Software Foundation, Inc."
+msgstr "Copyright &copy; 2014, 2015, 2017 Free Software Foundation, Inc."
 
 #. type: Content of: <div><p>
-# | This page is licensed under a <a rel=\"license\"
-# | [-href=\"http://creativecommons.org/licenses/by-nd/3.0/us/\">Creative-]
-# | {+href=\"http://creativecommons.org/licenses/by-nd/4.0/\">Creative+}
-# | Commons [-Attribution-NoDerivs 3.0 United States-]
-# | {+Attribution-NoDerivatives 4.0 International+} License</a>.
-#, fuzzy
-#| msgid ""
-#| "This page is licensed under a <a rel=\"license\" href=\"http://"
-#| "creativecommons.org/licenses/by-nd/3.0/us/\">Creative Commons Attribution-"
-#| "NoDerivs 3.0 United States License</a>."
 msgid ""
 "This page is licensed under a <a rel=\"license\" href=\"http://"
 "creativecommons.org/licenses/by-nd/4.0/\">Creative Commons Attribution-"
 "NoDerivatives 4.0 International License</a>."
 msgstr ""
-"Esta página está licenciada sob uma licença <a rel=\"license\" href=\"http://"
-"creativecommons.org/licenses/by-nd/3.0/us/deed.pt_BR\">Creative Commons "
-"Atribuição-SemDerivações 3.0 Estados Unidos</a>."
+"Esta página está licenciada sob uma licença <a rel=\"license\" href=\""
+"http://creativecommons.org/licenses/by-nd/4.0/deed.pt_BR\">Creative Commons "
+"Atribuição-SemDerivações 4.0 Internacional</a>."
 
 #. TRANSLATORS: Use space (SPC) as msgstr if you don't want credits.
 #. type: Content of: <div><div>
@@ -358,7 +329,6 @@ msgstr ""
 "<a href=\"mailto:rberaldo@cabaladada.org\">&lt;rberaldo@cabaladada.org&gt;</"
 "a>, 2012"
 
-# type: Content of: <div><p>
 #.  timestamp start 
 #. type: Content of: <div><p>
 msgid "Updated:"