# HG changeset patch
# User Felipe G. Nievinski <fgnievinski@gmail.com>
# Date 1388943471 7200
#      Sun Jan 05 15:37:51 2014 -0200
# Node ID c8efe9f83536512b8c4ede3dc4b492ba3be0b407
# Parent  f07d9cfd22a8a1c684a04403679d7415685630dc
keywords docs minor update (bug #41108)

diff -r f07d9cfd22a8 -r c8efe9f83536 libinterp/corefcn/help.cc
--- a/libinterp/corefcn/help.cc	Sun Jan 05 15:32:24 2014 -0200
+++ b/libinterp/corefcn/help.cc	Sun Jan 05 15:37:51 2014 -0200
@@ -452,8 +452,9 @@
 
   pair_type ("case",
     "-*- texinfo -*-\n\
+@deftypefn {Keyword} {} case @var{value}\n\
 @deftypefn {Keyword} {} case @{@var{value}@}\n\
-A case statement in an switch.  Octave cases are exclusive and do not\n\
+A case statement in a switch.  Octave cases are exclusive and do not\n\
 fall-through as do C-language cases.  A switch statement must have at least\n\
 one case.  See @code{switch} for an example.\n\
 @seealso{switch}\n\
@@ -462,6 +463,7 @@
   pair_type ("catch",
     "-*- texinfo -*-\n\
 @deftypefn {Keyword} {} catch\n\
+@deftypefn {Keyword} {} catch @var{value}\n\
 Begin the cleanup part of a try-catch block.\n\
 @seealso{try}\n\
 @end deftypefn"),
@@ -507,65 +509,65 @@
   pair_type ("end",
     "-*- texinfo -*-\n\
 @deftypefn {Keyword} {} end\n\
-Mark the end of any @code{for}, @code{if}, @code{do}, @code{while}, or\n\
-@code{function} block.\n\
-@seealso{for, parfor, if, do, while, function}\n\
+Mark the end of any @code{for}, @code{parfor}, @code{if}, @code{do}, @code{while}, \n\
+@code{function}, @code{switch}, @code{try}, or @code{unwind_protect} block.\n\
+@seealso{for, parfor, if, do, while, function, switch, try, unwind_protect}\n\
 @end deftypefn"),
 
   pair_type ("end_try_catch",
     "-*- texinfo -*-\n\
 @deftypefn {Keyword} {} end_try_catch\n\
 Mark the end of an @code{try-catch} block.\n\
-@seealso{try, catch}\n\
+@seealso{try, catch, end}\n\
 @end deftypefn"),
 
   pair_type ("end_unwind_protect",
     "-*- texinfo -*-\n\
 @deftypefn {Keyword} {} end_unwind_protect\n\
 Mark the end of an unwind_protect block.\n\
-@seealso{unwind_protect}\n\
+@seealso{unwind_protect, end}\n\
 @end deftypefn"),
 
   pair_type ("endfor",
     "-*- texinfo -*-\n\
 @deftypefn {Keyword} {} endfor\n\
 Mark the end of a for loop.  See @code{for} for an example.\n\
-@seealso{for}\n\
+@seealso{for, end}\n\
 @end deftypefn"),
 
   pair_type ("endfunction",
     "-*- texinfo -*-\n\
 @deftypefn {Keyword} {} endfunction\n\
 Mark the end of a function.\n\
-@seealso{function}\n\
+@seealso{function, end}\n\
 @end deftypefn"),
 
   pair_type ("endif",
     "-*- texinfo -*-\n\
 @deftypefn {Keyword} {} endif\n\
 Mark the end of an if block.  See @code{if} for an example.\n\
-@seealso{if}\n\
+@seealso{if, end}\n\
 @end deftypefn"),
 
   pair_type ("endparfor",
     "-*- texinfo -*-\n\
 @deftypefn {Keyword} {} endparfor\n\
 Mark the end of a parfor loop.  See @code{parfor} for an example.\n\
-@seealso{parfor}\n\
+@seealso{parfor, end}\n\
 @end deftypefn"),
 
   pair_type ("endswitch",
     "-*- texinfo -*-\n\
 @deftypefn {Keyword} {} endswitch\n\
 Mark the end of a switch block.  See @code{switch} for an example.\n\
-@seealso{switch}\n\
+@seealso{switch, end}\n\
 @end deftypefn"),
 
   pair_type ("endwhile",
     "-*- texinfo -*-\n\
 @deftypefn {Keyword} {} endwhile\n\
 Mark the end of a while loop.  See @code{while} for an example.\n\
-@seealso{do, while}\n\
+@seealso{do, while, end}\n\
 @end deftypefn"),
 
   pair_type ("for",
@@ -595,7 +597,7 @@
 
   pair_type ("global",
     "-*- texinfo -*-\n\
-@deftypefn {Keyword} {} global\n\
+@deftypefn {Keyword} {} global @var{var}\n\
 Declare variables to have global scope.\n\
 \n\
 @example\n\
@@ -676,7 +678,7 @@
   pair_type ("static",
     "-*- texinfo -*-\n\
 @deftypefn {Keyword} {} static\n\
-This function has been deprecated in favor of persistent.\n\
+This statement has been deprecated in favor of persistent.\n\
 @seealso{persistent}\n\
 @end deftypefn"),
 
@@ -716,7 +718,7 @@
 
   pair_type ("until",
     "-*- texinfo -*-\n\
-@deftypefn {Keyword} {} until\n\
+@deftypefn {Keyword} {} until (@var{cond})\n\
 End a do-until loop.  See @code{do} for an example.\n\
 @seealso{do}\n\
 @end deftypefn"),